import Action from '../../types/Store/Actions';
import { Device } from '../..//types/Device/Device';

export type DeviceState = StoreState<Device>;

export const INITIAL_STATE = {
  code: '',
  isCurrentUserUsed: 0,
  isOnline: 0,
  isUsed: 0,
  operatorId: 0,
  operatorName: '',
  position: '',
  positionId: '',
  rates: [],
};

export const updateDeviceData = (entity: DeviceState): Action => ({
  type: 'UPDATE_DEVICE_DATA',
  payload: entity,
});

export default function device(
  state: Device = INITIAL_STATE,
  actions: Action,
): Device {
  switch (actions.type) {
    case 'UPDATE_DEVICE_DATA':
      return {
        ...state,
        ...actions.payload,
      };
    default:
      return state;
  }
}
